/*
VODKA-INDUCED ENTERTAINMENT ADVANCED SOUND MANAGER v0.9.1 - HEADER FILE
BY GERARD 'ALUMIUN' WATSON

MODIFIED BY WOLF 'WSJ' SKEVOS-JONES
*/

#ifndef _VIEASM_H_
#define _VIEASM_H_

#include <SDL_mixer.h> // Duh.
#include <string.h>    // For memset
#include <stdio.h>     // For printf

//#define VERBOSE        // Verbose mode?

typedef struct
{
    Mix_Chunk *chunk;
    char *name;
} sample;

/* defines for management */

// WSJ: sound channel list
enum {
    chan_item,
    chan_item2,
    chan_ambient_loop,
    chan_ambient_1shot,
    chan_local_loop,
    chan_weapon_fire,
    chan_weapon_bolt,
    chan_weapon_actor,
    chan_voice_boss,
    chan_voice_guard,
    chan_voice_dog,
    chan_ricochet,
    chan_explosion,
    chan_pushwall,
    chan_door,
    ASM_MAXCHANNELS
};

/* #defined functions */

// ASM_AbortIfClosed
// Checks if the device is open, returns if it isn't
// Cunning lack of semi-colon means return values can be used appropriately :)

#ifdef VERBOSE
#define ASM_AbortIfClosed if(!ASM_IsOpen()) printf("Not open.\n"); if(!ASM_IsOpen()) return
#else
#define ASM_AbortIfClosed if(!ASM_IsOpen()) return
#endif

/* Other, 'real' functions */

extern bool ASM_Open(int frequency, bool use8bit, int buffersize, Uint8 sndvolume, Uint8 musvolume, bool reverse);
extern bool ASM_IsOpen(void);
extern bool ASM_PlayMusic(char *musfile);
extern sample ASM_Cache(char *sndfile, const char* name);
extern int ASM_PlaySound(sample &sound, int channel, bool looped);
extern void ASM_Uncache(sample &chunk);
extern void ASM_ChangeVolume(Uint8 sndvolume, Uint8 musvolume);
extern void ASM_Close(void);
extern void ASM_ReverseStereo(bool reverse);

#endif  // _VIEASM_H_
